#ifndef __CDTW_H__
#define __CDTW_H__

#define _CRT_SECURE_NO_WARNINGS

#ifndef MAT_TYPE
#define MAT_TYPE double
#endif

//#define PRINT_DEBUG

/*
	cumulative cost matrix data strucure
*/
typedef
struct cdtwCumCost
{
	MAT_TYPE cumCost;			/* cumulative cost */
	int cumRows,cumCols;		/* # vertical and horizontal steps */
	struct cdtwCumCost* next;	/* next point in the path */
}
cdtwCC;

/**
	Find sequence alignment using CDTW.

	@param costMatrix input costMatrix.
	@param rows rows of the costMatrix (i.e. size of seq1).
	@param cols cols of the costMatrix (i.e. size of seq2).
	@param radius defines the neighborhood in the search for the best starting point.
	@param idSeq1 address of the id array for sequence 1.
	@param idSeq2 address of the id array for sequence 2.
	@param nPairs address of the # of pairs (i.e. size of the id array).

	@return Returns the total cumulative cost.
*/
MAT_TYPE cdtw(const MAT_TYPE* costMatrix, const int rows, const int cols, const int radius,
			  int** idSeq1, int** idSeq2, int* nPairs);

#endif